﻿using System;
using Microsoft.Practices.Prism.ViewModel;

namespace FilteringXamGrid.Models
{
    public class Section : NotificationObject, ICloneable
    {
        private int _sectionId;
        public int SectionId
        {
            get { return _sectionId; }
            set
            {
                //ignore if values are equal
                if (value == _sectionId) return;

                _sectionId = value;

                RaisePropertyChanged(() => SectionId);
            }
        }

        private String _sectionName;
        public String SectionName
        {
            get { return _sectionName; }
            set
            {
                //ignore if values are equal
                if (value == _sectionName) return;

                _sectionName = value;

                RaisePropertyChanged(() => SectionName);
            }
        }

        public object Clone()
        {
            return new Section
            {
                SectionId = this.SectionId,
                SectionName = this.SectionName
            };
        }
    }
}
