﻿using System;
using Microsoft.Practices.Prism.ViewModel;

namespace FilteringXamGrid.Models
{
    public class Url : NotificationObject
    {
        private String _urlName;
        public String UrlName
        {
            get { return _urlName; }
            set
            {
                //ignore if values are equal
                if (value == _urlName) return;

                _urlName = value;

                RaisePropertyChanged(() => UrlName);
            }
        }

        private Section _sector;
        public Section Section
        {
            get { return _sector; }
            set
            {
                //ignore if values are equal
                if (value == _sector) return;
               
                _sector = value;


                RaisePropertyChanged(() => Section);
                RaisePropertyChanged(() => SectionName);
            }
        }

        private Category _category;
        public Category Category
        {
            get { return _category; }
            set
            {
                //ignore if values are equal
                if (value == _category) return;
                
                _category = value;


                RaisePropertyChanged(() => Category);
                RaisePropertyChanged(() => CategoryName);
            }
        }


        public string SectionName
        {
            get
            {
                if (Section != null)
                {
                    return Section.SectionName;
                }
                return string.Empty;
            }
        }

        public string CategoryName
        {
            get
            {
                if (Category != null)
                {
                    return Category.CategoryName;
                }
                return string.Empty;
            }
        }

    }
}
