﻿using System.Collections.Generic;
using System.Diagnostics;
using FilteringXamGrid.Models;
using Microsoft.Practices.Prism;
using Microsoft.Practices.Prism.ViewModel;
using System;
using System.Collections.ObjectModel;
using System.Linq;
using Microsoft.Practices.Prism.Commands;

namespace FilteringXamGrid.ViewModels
{
    public class UrlViewModel : NotificationObject
    {

        public UrlViewModel()
        {
            _unloadedCommand = new DelegateCommand(OnUnloaded);
            _loadedCommand = new DelegateCommand(OnLoaded);

           

            Urls = new ObservableCollection<Url>();
            Categories = new ObservableCollection<Category>();
            Sections = new ObservableCollection<Section>();

           // Init();

        }

        
        private void Init()
        {
            Stopwatch sw = new Stopwatch();
            sw.Start();

            Random rnd = new Random();

            //init categories
            Categories.Add(new Category { CategoryId = 0, CategoryName = "Category 1" });
            Categories.Add(new Category { CategoryId = 1, CategoryName = "Category 2" });
            Categories.Add(new Category { CategoryId = 2, CategoryName = "Category 3" });
            Categories.Add(new Category { CategoryId = 3, CategoryName = "Category 4" });

            //int sections
            Sections.Add(new Section { SectionId = 0, SectionName = "Section 1" });
            Sections.Add(new Section { SectionId = 1, SectionName = "Section 2" });
            Sections.Add(new Section { SectionId = 2, SectionName = "Section 3" });
            Sections.Add(new Section { SectionId = 3, SectionName = "Section 4" });

            
            SelectedSection = Sections.FirstOrDefault();
            SelectedCategory = Categories.FirstOrDefault();
            var list = new List<Url>();

            for (int i = 0; i < 100; i++)
            {
                int c = rnd.Next(Categories.Count);
                int s = rnd.Next(Sections.Count);

                list.Add(new Url
                {
                    Category = Categories[c],
                    Section = s!=2? Sections[s]:null,
                    UrlName = "http://www.infragistics.com/community/forums/AddPost.aspx?ForumID=http://www.infragistics.com/community/forums/AddPost.aspx?ForumID=http://www.infragistics.com/community/forums/AddPost.aspx?ForumID=" + i
                });

            }

            sw.Stop();
            Console.WriteLine("Elapsed={0}", sw.Elapsed);
            Urls  = new ObservableCollection<Url>(list);
        }

        #region Properties

        #region Urls

        private ObservableCollection<Url> _urls;

        public ObservableCollection<Url> Urls
        {
            get { return _urls; }
            set
            {
                //ignore if values are equal
                if (value == _urls) return;

                _urls = value;

                RaisePropertyChanged(() => Urls);
            }
        }

        #endregion

        #region Selected Section

        private Section _selectedSection;

        public Section SelectedSection
        {
            get { return _selectedSection; }
            set
            {
                //ignore if values are equal
                if (value == _selectedSection) return;

                _selectedSection = value;

                RaisePropertyChanged(() => SelectedSection);
            }
        }

        #endregion

        #region Selected Category

        private Category _selectedCategory;

        public Category SelectedCategory
        {
            get { return _selectedCategory; }
            set
            {
                //ignore if values are equal
                if (value == _selectedCategory) return;

                _selectedCategory = value;

                RaisePropertyChanged(() => SelectedCategory);
            }
        }

        #endregion


        #region Categories
        private ObservableCollection<Category> _categories;

        public ObservableCollection<Category> Categories
        {
            get { return _categories; }
            set
            {
                //ignore if values are equal
                if (value == _categories) return;

                _categories = value;

                RaisePropertyChanged(() => Categories);
            }
        }
        #endregion

        #region Sections
        private ObservableCollection<Section> _sections;

        public ObservableCollection<Section> Sections
        {
            get { return _sections; }
            set
            {
                //ignore if values are equal
                if (value == _sections) return;

                _sections = value;

                RaisePropertyChanged(() => Sections);
            }
        }
        #endregion

        #endregion

         #region Load / unload commands

        private readonly DelegateCommand _loadedCommand;

        public DelegateCommand LoadedCommand
        {
            get { return _loadedCommand; }
        }

        protected void OnLoaded()
        {
           Init();
        }

        private readonly DelegateCommand _unloadedCommand;

        public DelegateCommand UnloadedCommand
        {
            get { return _unloadedCommand; }
        }

        protected void OnUnloaded()
        {
            
        }

        #endregion
    }
}
